leetCode No.378 Kth Smallest Element in a Sorted Matrix

来源:互联网 发布:什么是c语言 编辑:程序博客网 时间:2024/05/22 08:25

题目

Given a n x n matrix where each of the rows and columns are sorted in ascending order, find the kth smallest element in the matrix.


Note that it is the kth smallest element in the sorted order, not the kth distinct element.

Example:

matrix = [ 
[ 1, 5, 9],
[10, 11, 13],
[12, 13, 15]
],
k = 8,

return 13.


标签:Binary Search,Heap
相似题目: (M) Find K Pairs with Smallest Sums

题意

给定一个行和列都是从小到大排序的n维方阵。找到整个方阵中按从小到大排序第k个元素。

解题思路

假设当前点为(x,y)则当前点的相邻点为:(x,y+1),(x+1,y)。当前点的相邻点即为数值上比当前点大的相近的点。所以每次将相邻点放进优先队列(堆)直到达到想要得到的位置。

代码

import java.util.PriorityQueue;public class Solution {    public int kthSmallest(int[][] matrix, int k)    {        int m=matrix.length;        if(m==0)            return 0;        int n=matrix[0].length;        int cnt=0;        boolean[][] used=new boolean[m][n];        PriorityQueue<kthsNode> heap=new PriorityQueue<>();        heap.add(new kthsNode(0, 0, matrix[0][0]));        used[0][0]=true;        kthsNode node=null;        int[] xoff={0,1};        int[] yoff={1,0};        while(cnt<k)        {            node=heap.poll();            int x=node.x;            int y=node.y;            for(int i=0;i<2;i++)            {                int xx=x+xoff[i];                int yy=y+yoff[i];                if(xx>=0&&xx<m&&yy>=0&&yy<n&&!used[xx][yy])                {                    used[xx][yy]=true;                    heap.add(new kthsNode(xx, yy, matrix[xx][yy]));                }            }            cnt++;        }        return node.val;    }}class kthsNode implements Comparable<kthsNode>{    int x,y;    int val;    public kthsNode(int x,int y,int val)    {        this.x=x;        this.y=y;        this.val=val;        // TODO Auto-generated constructor stub    }    @Override    public int compareTo(kthsNode o)    {        // TODO Auto-generated method stub        return val-o.val;    }}

相关链接

源代码(github)
原题

0 0
原创粉丝点击